local num_iter_default = 1000000

local filename = tostring(select(1, ...) or "")
local option = tostring(select(2, ...) or "")
local num_iter = tonumber(select(3, ...) or num_iter_default)

if filename == "" then
  print("Usage: lua bench.lua <filename.lua> <method> <num_iter>")
else
  local res, err = loadfile(filename)
  if not res then
    print("Failed to load file", filename, ":\n", err)
  else
    local status, res = pcall(res)
    if not status then
      print("Failed to run file", filename, ":\n", status)
    elseif type(res) ~= "table" then
      print(
          "Bad file", filename,
          "result: handler_map table expected, got", res
        )
    else
      local handler = res[option]
      if not handler then
        print ([[
      Usage: lua bench.lua <filename.lua> <method> <num_iter>
      <method>: for file ]]..filename..[[ one of]])
      for name, method in pairs(res) do
        print("* "..name)
      end
        print([[
      <num_iter> : number of iterations, default ]]..num_iter_default..[[
      ]])
      else
        for i = 1, num_iter do
          handler()
        end
      end
    end
  end
end
